#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long int n, q, a, b, broj, i, j;

    cin>>n>>q;

    long long int niz[n], matrica[n][n];

    for(i=0; i<n; i++)
    {
        cin>>niz[i];
    }

    for(i=0; i<n; i++)
    {
        for(j=i; j<n; j++)
        {
            if(j==i)
            {
                matrica[i][j]=niz[i];
            }
            else
            {
                matrica[i][j]=matrica[i][j-1]&niz[j];
            }
        }
    }

    for(i=0; i<q; i++)
    {
        cin>>a>>b;

        cout<<matrica[a-1][b-1]<<endl;
    }

    return 0;
}